//----------------------------------------------------------------------------------
// aviutl GPUtB^ 0
// Copyright (c) 2006  N099
//----------------------------------------------------------------------------------
#include <windows.h>
#include <xmmintrin.h>
#include <strsafe.h>
#include <new>

#include <d3d9.h>
#include <d3dx9.h>
#include <dxerr.h>

#include "filter.h"
#include "support.h"

//---------------------------------------------------------------------
// global
//---------------------------------------------------------------------
LPDIRECT3D9 g_pD3D = NULL;
LPDIRECT3DDEVICE9 g_pd3dDevice = NULL;
GpuFilter *g_pGpuFilter = NULL;

//ptH[}Xp
#ifdef DBG_WINDOW
struct PCount { LARGE_INTEGER c; TCHAR s[16]; };
HWND g_debugWindow = 0;
DWORD g_cpuFreq = 0;
double g_ticCoeff = 1.0;
double g_timCoeff = 1.0;
PCount g_count[6];
void getCount(int i, const TCHAR *tag);
void printCount(int n);
#else
#define getCount(i, t)
#define printCount(n)
#endif

//---------------------------------------------------------------------
// tB^\̒`
//---------------------------------------------------------------------
// UNICODErh邽ߏςɂȂĂ܂iDXTrace()Ȃ߁j
#define TRACK_N 15
LPSTR track_name[] =
{ "Y(offs)", "Y(gain)" ,  "Cb(offs)", "Cb(gain)",
  "Cr(offs)", "Cr(gain)", "R(offs)",  "R(gain)",  "R(gamm)", 
  "G(offs)",  "G(gain)",  "G(gamm)",  "B(offs)",  "B(gain)", "B(gamm)" };
int track_default[] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
int track_s[] = { -256, -256, -256, -256, -256, -256, -256, -256, -256, -256, -256, -256, -256, -256, -256 };
int track_e[] = { 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256, 256 };
enum { T_YOF, T_YGA, T_CBOF, T_CBGA, T_CROF, T_CRGA,
	T_ROF, T_RGA, T_RGM, T_GOF, T_GGA, T_GGM,T_BOF, T_BGA, T_BGM };

#define CHECK_N 2
LPSTR check_name[] =
{ "F16", "pow2" };
int    check_default[] = { 0, 0 };
enum { C_F16, C_POW2 };

FILTER_DLL filter = {
	FILTER_FLAG_EX_INFORMATION, 0, 0,
	(TCHAR*)"GPUF␳(test)",
	TRACK_N, (TCHAR**)track_name, track_default, track_s, track_e,
	CHECK_N, (TCHAR**)check_name, check_default,
	func_proc,
	func_init,
	func_exit,
	NULL,
	NULL, //func_WndProc,
	NULL, NULL, NULL, 0,
	(TCHAR*)"gpu0 by N099, ver0.0",
	NULL,  NULL,
};

//---------------------------------------------------------------------
//     tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
	return &filter;
}

//---------------------------------------------------------------------
// ɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_init(FILTER *fp)
{
	//init D3D    
	g_pD3D = Direct3DCreate9(D3D_SDK_VERSION);
	if(NULL == g_pD3D) {
		return FALSE;
	}

	//create device
	HRESULT hr;
	D3DPRESENT_PARAMETERS d3dpp; 

	ZeroMemory(&d3dpp, sizeof(d3dpp));
	d3dpp.Windowed = TRUE;
	d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
	d3dpp.BackBufferFormat = D3DFMT_UNKNOWN;

	hr = g_pD3D->CreateDevice(
		D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, fp->hwnd,
		D3DCREATE_SOFTWARE_VERTEXPROCESSING|D3DCREATE_NOWINDOWCHANGES, 
		&d3dpp, &g_pd3dDevice );
	if(FAILED(hr)) {
		return FALSE;
	}

	//GpuFilter
	g_pGpuFilter = new(std::nothrow) GpuFilter;
	if(NULL == g_pGpuFilter){
		return FALSE;
	}

	//FGtFNg̃[h
	if(!g_pGpuFilter->Init(g_pD3D, g_pd3dDevice, TEXT("gpu0.fx")))
		return FALSE;

#ifdef DBG_WINDOW
	//get CPU freq from registryi܂萳mł͂Ȃj
	HKEY hKey;
	DWORD size = sizeof(DWORD);
	if(ERROR_SUCCESS == RegOpenKeyEx(HKEY_LOCAL_MACHINE, 
		TEXT("HARDWARE\\DESCRIPTION\\System\\CentralProcessor\\0"),
		0, KEY_READ, &hKey))
	{
		g_cpuFreq = 0;
		RegQueryValueEx(hKey, TEXT("~MHz"), NULL, NULL, (LPBYTE)&g_cpuFreq, &size);
		RegCloseKey(hKey);
	}

	//coeff PerformanceCounter ticks to CPU cycles
	LARGE_INTEGER ticFreq = {0,0};
	QueryPerformanceFrequency(&ticFreq);
	if(g_cpuFreq>0 && ticFreq.QuadPart>0){
		g_ticCoeff = g_cpuFreq * 1000.0 * 1000.0 / (double)ticFreq.QuadPart;
		g_timCoeff = 1.0 / (double)ticFreq.QuadPart;
	}else{
		g_ticCoeff = g_timCoeff = 1.0;
	}

	//create debug window
	g_debugWindow = CreateWindow(TEXT("EDIT"), TEXT("Debug GPU0"),
		WS_VISIBLE | WS_POPUPWINDOW | WS_CAPTION | ES_MULTILINE | ES_READONLY,
		CW_USEDEFAULT, 0,
		180, 160,
		fp->hwnd, NULL, fp->dll_hinst, NULL);
	if(g_debugWindow){
		SendMessage(g_debugWindow, WM_SETFONT, 
			(WPARAM)GetStockObject(OEM_FIXED_FONT), (LPARAM)TRUE);
	}
#endif

	return TRUE;
}

//---------------------------------------------------------------------
// IɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_exit(FILTER *fp)
{
#ifdef DBG_WINDOW
	if(g_debugWindow) DestroyWindow(g_debugWindow);
#endif

	SAFE_DELETE(g_pGpuFilter);
	SAFE_RELEASE(g_pd3dDevice);
	SAFE_RELEASE(g_pD3D);

	return TRUE;
}


//---------------------------------------------------------------------
// tB^֐
//---------------------------------------------------------------------
BOOL func_proc(FILTER *fp, FILTER_PROC_INFO *fpip)
{
	static int track[TRACK_N];
	static int check[CHECK_N];
	static int w, h;
	int i =0;
	bool chg_t, chg_c, chg_sz;

	if(!g_pGpuFilter) return FALSE;

	getCount(i++, TEXT("Init"));

	//ύX̃`FbN
	if(memcmp(fp->track, track, sizeof(track))){
		chg_t = true;
		memcpy(track, fp->track, sizeof(track));
	}else{
		chg_t = false;
	}
	if(memcmp(fp->check, check, sizeof(check))){
		chg_c = true;
		memcpy(check, fp->check, sizeof(check));
	}else{
		chg_c = false;
	}
	if(fpip->w != w || fpip->h != h){
		chg_sz = true;
		w = fpip->w;
		h = fpip->h;
	}else{
		chg_sz = false;
	}

	//p[^ύXꂽꍇ
	if(chg_sz || chg_c){
		GpuFilter::PIXEL_FORMAT fmt = fp->check[C_F16] ? (GpuFilter::F16) : (GpuFilter::F32);
		bool pow2 = fp->check[C_POW2] ? true : false;

		g_pGpuFilter->ReleaseResources();
		g_pGpuFilter->AllocResources(w, h, fpip->max_w,	fmt, GpuFilter::COPY, pow2);
		g_pGpuFilter->SetParams(fp->track, TRACK_N);
		getCount(i++, TEXT("Alloc"));
	}else if(chg_t){
		g_pGpuFilter->SetParams(fp->track, TRACK_N);
		getCount(i++, TEXT("Param"));
	}

	//f[^GPUɓ]
	if(!g_pGpuFilter->PutImage(fpip->ycp_edit)) return FALSE;
	getCount(i++, TEXT("Put  "));

	//GPUŏ
	if(!g_pGpuFilter->ProcImage()) return FALSE;
#ifdef DBG_WINDOW
	//R}hobt@ɂ
	DWORD p;
	g_pd3dDevice->ValidateDevice(&p);
#endif
	getCount(i++, TEXT("Proc "));

	//o̓f[^o
	if(!g_pGpuFilter->GetImage(fpip->ycp_edit)) return FALSE;
	getCount(i++, TEXT("Get  "));

	printCount(i);

	return TRUE;
}

//ptH[}Xp
#ifdef DBG_WINDOW
void getCount(int i, const TCHAR *tag)
{
	QueryPerformanceCounter(&g_count[i].c);
	lstrcpy(g_count[i].s, tag);
}

void printCount(int n)
{
	TCHAR buf[512];
	TCHAR buf0[64];
	TCHAR *fmt = TEXT("?");
	double clk;
	int h,w;

	if(NULL == g_debugWindow) return;
	if(g_pGpuFilter){
		h = g_pGpuFilter->GetTextureHeight();
		w = g_pGpuFilter->GetTextureWidth();
		fmt = (GpuFilter::F32 == g_pGpuFilter->GetTextureFormat())
			? TEXT("F32") : TEXT("F16");
	}else{
		h = w = 0;
	}

	wsprintf(buf, TEXT("size:%dx%d(%s)\r\ncycles(CPU:%dMHz)\r\n"), 
		w,h, fmt, g_cpuFreq);
	for(int i=1; i<n; ++i){
		clk = (double)(g_count[i].c.QuadPart - g_count[i-1].c.QuadPart)*g_ticCoeff;
		StringCchPrintf(buf0, 64, TEXT("%s:%5e\r\n"), g_count[i].s, clk);
		lstrcat(buf, buf0);
	}
	SendMessage(g_debugWindow, WM_SETTEXT, 0, (LPARAM)buf);  
}
#endif