//----------------------------------------------------------------------------
// F␳tB^
// Copyright (c) 2006 N099
//----------------------------------------------------------------------------

//----------------------------------------------------------------------------
// ^[Qbg̃eNX`
//----------------------------------------------------------------------------
texture txTgt;
texture txTmp;

sampler2D samTgt =
sampler_state
{
    Texture = <txTgt>;
    AddressU = Clamp;
    AddressV = Clamp;
    MinFilter = Point;
    MagFilter = Linear;
    MipFilter = Linear;
};
sampler2D samTmp =
sampler_state
{
    Texture = <txTmp>;
    AddressU = Clamp;
    AddressV = Clamp;
    MinFilter = Point;
    MagFilter = Linear;
    MipFilter = Linear;
};

//----------------------------------------------------------------------------
// tB^W
//----------------------------------------------------------------------------
float4 ycOffs;   //YCItZbg
float4 ycAmp;    //YC{
float4 bgrOffs;  //RGBItZbg
float4 bgrAmp;   //RGB{
float4 bgrGamma; //RGBK}

//----------------------------------------------------------------------------
// RGB <-> YC (CCIR 601-1:derived from TIFF 6.0 section 21, 1992/6/3)
//----------------------------------------------------------------------------
float4x4 matYC2BGR = 
{ 0.0f, 0.0f,      0.0f,      0.0f,
  0.0f, 1.0f,  1.77200f,      0.0f,
  0.0f, 1.0f, -0.34414f, -0.71414f,
  0.0f, 1.0f,      0.0f,  1.40200f }; 

float4x4 matBGR2YC = 
{ 0.0f,      0.0f,      0.0f,      0.0f,
  0.0f,    0.114f,   0.5870f,  0.29900f,
  0.0f,  0.50000f, -0.33126f, -0.16874f,
  0.0f, -0.08131f, -0.41869f,  0.50000f }; 
  
//-----------------------------------------------------------------------------
// Pixel Shader: YUVCorrectionPS
// Desc: YUV␳
//-----------------------------------------------------------------------------
float4 YUVCorrectionPS(float2 Tex : TEXCOORD0) : COLOR0
{
	return tex2D(samTgt, Tex) * ycAmp + ycOffs;
}

//-----------------------------------------------------------------------------
// Pixel Shader: RGBCorrectionPS
// Desc: RGB␳
//-----------------------------------------------------------------------------
float4 RGBCorrectionPS(float2 Tex : TEXCOORD0) : COLOR0
{
	float4 tmp;
	float4 bgr = mul(matYC2BGR, tex2D(samTmp, Tex));
	tmp = saturate(bgr);
	bgr -= tmp;
	bgr += pow(tmp, bgrGamma);
	bgr = (bgr * bgrAmp) + bgrOffs;
	return mul(matBGR2YC, bgr);
}


//-----------------------------------------------------------------------------
// Technique: ColorCorrection
// Desc: F␳
//-----------------------------------------------------------------------------
technique ColorCorrection
{
	pass p0
	{
		VertexShader = null;
		PixelShader = compile ps_2_0 YUVCorrectionPS();
		ZEnable = false;
	}
	
	pass p1
	{
		VertexShader = null;
		PixelShader = compile ps_2_0 RGBCorrectionPS();
		ZEnable = false;
	}
}
