//----------------------------------------------------------------------------------
// aviutl GPUtB^ T|[gNX
// Copyright (c) 2006  N099
//----------------------------------------------------------------------------------
#pragma once

struct TexChain;

class GpuFilter
{
public:
	enum PIXEL_FORMAT { F32, F16, S16, Unknown };
	enum ACCESS_TYPE  { DIRECT, COPY, NONE };

private:
	IDirect3D9 *m_pD3D; //IDirect3D9IuWFNg
	IDirect3DDevice9 *m_pd3dDevice; //D3DfoCX

	IDirect3DTexture9 *m_pTex; //ANZXeNX`
	IDirect3DTexture9 *m_pTexSys; //Rs[ɗpeNX`
	IDirect3DTexture9 *m_pTexTmp; //f[^̈ꎞeNX`
	
	IDirect3DVertexBuffer9 *m_pVert; //`p_
	IDirect3DVertexDeclaration9 *m_pVertDec; //`p_`

	ID3DXEffect *m_pEffect; //GtFNg
	ID3DXEffectPool *m_pPool; //GtFNgv[igpj

	TexChain *m_pTexChain;
	__m128 *m_pFloatTmp;

	int m_width;
	int m_height;
	int m_wMax;
	int m_wTex;
	int m_hTex;

	bool m_sse;

	PIXEL_FORMAT m_texFormat; //eNX`̃tH[}bg
	ACCESS_TYPE m_accType; //eNX`ANZX@
	bool m_pow2; //eNX`TCY2̗ݏɂ邩ǂ

public:
	GpuFilter();
	~GpuFilter();

	bool Init(IDirect3D9 *pD3D, IDirect3DDevice9 *pd3dDevice, const TCHAR *effect);
	bool AllocResources(int w, int h, int w_max, PIXEL_FORMAT fmt, ACCESS_TYPE type, bool pow2);
	bool ReleaseResources(void);
	bool SetParams(int *param, int n);
	bool PutImage(const PIXEL_YC *data);
	bool GetImage(PIXEL_YC *data);
	bool ProcImage(void);

	int GetTextureWidth(void) const { return m_wTex; }
	int GetTextureHeight(void) const { return m_hTex; }
	PIXEL_FORMAT GetTextureFormat(void) const { return m_texFormat; }

private:
	HRESULT CheckDeviceCap(void);
	HRESULT CreateVert(const D3DVERTEXELEMENT9 *decl);
	HRESULT CreateEffect(const TCHAR *path);
	HRESULT CreateTexture(IDirect3DTexture9 **ppTex, IDirect3DTexture9 **ppTexSys);
	HRESULT CreateTempTexture(IDirect3DTexture9 **ppTex);
	HRESULT PutPixelDataDirect(IDirect3DTexture9 *dst, const PIXEL_YC *src);
	HRESULT GetPixelDataDirect(PIXEL_YC *dst, IDirect3DTexture9 *src);
	HRESULT PutPixelData(IDirect3DTexture9 *dst, IDirect3DTexture9 *tmp, const PIXEL_YC *src);
	HRESULT GetPixelData(PIXEL_YC *dst, IDirect3DTexture9 *src, IDirect3DTexture9 *tmp);
};

//---------------------------------------------------------------------
// macro
//---------------------------------------------------------------------
#ifndef SAFE_DELETE
#define SAFE_DELETE(p)       { if(p) { delete (p);     (p)=NULL; } }
#endif    
#ifndef SAFE_DELETE_ARRAY
#define SAFE_DELETE_ARRAY(p) { if(p) { delete[] (p);   (p)=NULL; } }
#endif    
#ifndef SAFE_RELEASE
#define SAFE_RELEASE(p)      { if(p) { (p)->Release(); (p)=NULL; } }
#endif
